
QGIS Application - Bug report #11441

Parallel multi-core rendering glitches with OTF reprojection

2014-10-19 03:23 AM - Anita Graser

Status: Closed

Priority: Normal

Assignee:

Category: Map Canvas

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 19717

Description

With active on-the-fly reprojection and parallel rendering, the map renders with big artifacts. I've tested the following project with both the

2.4 release and today's nightly:

https://github.com/FOSS4GAcademy/GST101FOSS4GLabs/tree/master/Module%204%20Lab/QGIS%202.2/Lab%204%20Data

Deactivating either OTF or parallel rendering fixes the problem as far as I can tell.

Related issues:

Related to QGIS Application - Bug report # 11746: Vertical lines appear as ar... Closed 2014-11-26

Associated revisions

Revision 4396e532 - 2017-05-16 05:20 AM - Nyall Dawson

Utilise thread safe proj API within QgsCoordinateTransform
Avoids unpredictable behavior when transforms are being

conducted in background threads, such as map renders.

Refs #11441

This commit:

1. Uses thread_local storage for projCtx objects, to ensure

that every thread correctly has its own projCtx context.

2. Refactors QgsCoordinateTransformPrivate so that the

projPJ source and destination objects are instead stored

in a map (by projCtx). This allows transforms to be

transparently performed using the correct projPJ objects

for the particular thread in which the transform is being

conducted. This approach avoids expensive detachment

of QgsCoordinateTransformPrivate, and allows a single

QgsCoordinateTransformPrivate to be safely utilised

by QgsCoordinateTransform objects in different threads.

Revision af3370d0 - 2017-05-22 04:40 AM - Nyall Dawson

Utilise thread safe proj API within QgsCoordinateTransform

Avoids unpredictable behavior when transforms are being conducted

in background threads, such as map renders.

Refs #11441

This commit:

1. Uses QThreadStorage for projCtx objects, to ensure that every

thread correctly has its own projCtx context

2. Refactors QgsCoordinateTransform so that the projPJ source and

destination objects are instead stored in a map (by projCtx). This

allows transforms to be transparently performed using the correct

projPJ objects for the particular thread in which the transform is

being conducted. This approach allows a single QgsCoordinateTransform

to be safely utilised in different threads.

History

#1 - 2014-10-19 05:15 AM - Giovanni Manghi

- Status changed from Open to Feedback

cannot confirm here, tested on master on both Linux and Windows (same project and data).

#2 - 2014-10-19 09:09 AM - Gary Sherman

Try turning off simplification and/or "Make lines appear less jagged..." and see if it goes away. We had a similar problem years ago and I don't recall the

root cause.
#3 - 2014-10-19 11:26 AM - Saber Razmjooei

There are layers from outside the OTF CRS. According to this website: http://prj2epsg.org/epsg/5070 Canada and Mexico are outside EPSG:5070's CRS

zone. I guess this causes the problem.

I have removed Mexico and Canada and the problem seems to have disappeared.

#4 - 2014-10-19 12:19 PM - Anita Graser

@Gary: Changing the simplification settings (values, on/off) or deactivating anti-aliasing didn't change the results.

@Saber: Even if I only use the US states (which should be within the CRS zone), these artifacts appear.

#5 - 2014-10-20 01:06 AM - Saber Razmjooei

It has become less frequent. To completely get rid of the problem, I saved western_states in 5070 and used that instead. But that does not explain the

source of problem.

#6 - 2014-10-20 02:22 AM - Martin Dobias

I cannot replicate the problem.

@Anita / @Saber - which version of Proj.4 do you use? Does it happen also if you use a wgs84 for destination CRS? To my (brief) knowledge, the used

epsg 5070 uses a grid file. Could you try some other projection for north america that does not involve reading of grid files? (based on parameters only)

Apparently the proj library versions < 4.8 were prone to errors when used in multi-threaded environment, but maybe we should also make use of contexts

introduced in 4.8:

https://trac.osgeo.org/proj/wiki/ThreadSafety

#7 - 2014-10-20 02:37 AM - Giovanni Manghi

Martin Dobias wrote:

I cannot replicate the problem.

@Anita / @Saber - which version of Proj.4 do you use? Does it happen also if you use a wgs84 for destination CRS? To my (brief) knowledge, the

used epsg 5070 uses a grid file. Could you try some other projection for north america that does not involve reading of grid files? (based on

parameters only)

Apparently the proj library versions < 4.8 were prone to errors when used in multi-threaded environment, but maybe we should also make use of

contexts introduced in 4.8:

https://trac.osgeo.org/proj/wiki/ThreadSafety

it seems anyway strange to me as I tested also on Windows (where anyone should have the same libraries) and cannot replicate the issue.

#8 - 2014-10-20 02:56 AM - Martin Dobias
Giovanni Manghi wrote:

it seems anyway strange to me as I tested also on Windows (where anyone should have the same libraries) and cannot replicate the issue.

Unfortunately this is not that strange. It is quite common that errors in multi-threaded code appear just for some people, while working flawlessly for others.

#9 - 2014-10-20 03:56 AM - Saber Razmjooei

It works fine in both WGS84 and 4269.

#10 - 2014-11-22 10:14 AM - Giovanni Manghi

still true?

#11 - 2014-11-22 01:34 PM - Anita Graser

Still true for me (Win8 OSGeo4W nightly 64bit).

#12 - 2015-05-11 01:46 AM - Giovanni Manghi

- Status changed from Feedback to Open

#13 - 2015-05-11 09:53 AM - Anita Graser

Still true for 2.8.1 (Win8 OSGeo4W 64bit).

#14 - 2015-10-11 09:14 AM - Anita Graser

- Target version set to Future Release - High Priority

Still true for 2.11 today.

#15 - 2016-01-23 09:58 AM - Martin Dobias

- Status changed from Open to Feedback

As far as I can tell from my tests, this problem was caused by a bug in proj.4 library: https://github.com/OSGeo/proj.4/issues/226

It has been fixed in proj 4.9.2 (released Sep 2015) which is now also available in osgeo4w (since end of Nov 2015). Could you please test again with the

latest proj4 version to see if the problem is gone?

#16 - 2016-01-23 10:32 AM - Anita Graser

- File projissues.PNG added

Unfortunately still around ... even with the new proj ..
projissues.PNG

Please put back to "open".

#17 - 2016-03-04 01:02 AM - Anita Graser

@Martin Can you please change the status back to open? Thanks!

#18 - 2016-03-04 01:04 AM - Martin Dobias

- Status changed from Feedback to Open

Maybe we can have a look at it in Girona...

#19 - 2017-01-09 12:42 AM - Giovanni Manghi

- Status changed from Open to Feedback

is there any update on this issue?

#20 - 2017-01-09 11:12 AM - Anita Graser

- File glitch219.PNG added

Still same error unfortunately. Tested with latest 2.19 in OSGeo4W - so not latest master

glitch219.PNG

#21 - 2017-01-10 04:40 AM - Jürgen Fischer

Anita Graser wrote:

so not latest master

not even master - qgis-dev is from (removed) master_2.   qgis-rel-dev should be more up to date (branched off from master_2 on release of 2.18)

#22 - 2017-01-10 05:17 AM - Giovanni Manghi

- Status changed from Feedback to Open

Jürgen Fischer wrote:

Anita Graser wrote:

so not latest master
not even master - qgis-dev is from (removed) master_2.   qgis-rel-dev should be more up to date (branched off from master_2 on release of 2.18)

There will ever be a master/qgis3 package on osgeo4w? Just a practical question: I do/did most of master testing on Windows because it was very

practical, if there will be no more master on osgeo4w I will have to review my strategy and compile daily on Linux.

#23 - 2017-01-10 05:40 AM - Jürgen Fischer

Giovanni Manghi wrote:

There will ever be a master/qgis3 package on osgeo4w?

sure.

#24 - 2017-01-10 07:56 AM - Anita Graser

Jürgen Fischer wrote:

qgis-rel-dev should be more up to date (branched off from master_2 on release of 2.18)

Ok, I'll try with qgis-rel-dev

#25 - 2017-01-10 09:09 AM - Anita Graser

Same issue in qgis-rel-dev

#26 - 2017-03-06 03:04 PM - Giovanni Manghi

- Affected QGIS version changed from master to 2.18.4

- Status changed from Open to Feedback

- Priority changed from High to Normal

- Target version deleted (Future Release - High Priority)

Anita Graser wrote:

Same issue in qgis-rel-dev

what about the (qgis3) master? any change?

#27 - 2017-03-07 02:42 PM - Anita Graser

Still same here with 2.99 from OSGeo4W.

#28 - 2017-03-08 12:20 AM - Giovanni Manghi
- Target version set to Version 3.0

- Status changed from Feedback to Open

- Affected QGIS version changed from 2.18.4 to master

#29 - 2017-05-01 01:07 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#30 - 2017-05-17 08:36 PM - Nyall Dawson

- Status changed from Open to Feedback

- Description updated

Anita - please test the next nightly 3.0 release as this is likely fixed now.

#31 - 2017-11-13 01:41 AM - Nyall Dawson

Anita -can we close this? Should be fixed in master and recent 2.18

#32 - 2017-11-13 05:49 PM - Anita Graser

- Status changed from Feedback to Closed

- Resolution set to fixed/implemented

Looks good! Thanks Nyall!

Files

glitch.png 236 KB 2014-10-19 Anita Graser

projissues.PNG 223 KB 2016-01-23 Anita Graser

glitch219.PNG 211 KB 2017-01-09 Anita Graser
